## org.apache.fop.fo
Class FONode

    java.lang.Object
      |
      +--org.apache.fop.fo.FONode

Direct Known Subclasses:
  FObj, FOText

public abstract class FONode
extends java.lang.Object

base class for nodes in the formatting object tree

Field Summary
`protected int` `bodyIndent`
`static int` `BREAK_AFTER` value of marker after break-after
`java.util.Vector` `children`
`protected int` `distanceBetweenStarts`
`protected int` `forcedStartOffset`
`protected int` `forcedWidth`
`protected boolean` `isInLabel`
`protected boolean` `isInListBody`
`protected boolean` `isInTableCell`
`protected int` `labelSeparation`
`protected LinkSet` `linkSet`
`protected int` `marker` where the layout was up to.
`protected int` `orphans`
`protected FObj` `parent`
`static int` `START` value of marker before layout begins
`protected int` `widows`

Constructor Summary
`protected` `FONode(FObj parent)`

Method Summary
`protected void` `addChild(FONode child)`
`void` `forceStartOffset(int offset)`
`void` `forceWidth(int width)`
`LinkSet` `getLinkSet()`
`java.util.Vector` `getMarkerSnapshot(java.util.Vector snapshot)` At the start of a new span area layout may be partway through a nested FO, and balancing requires rollback to this known point.
`FObj` `getParent()`
`Property` `getProperty(java.lang.String name)` lets outside sources access the property list first used by PageNumberCitation to find the "id" property returns null by default, overide this function when there is a property list
`abstract Status` `layout(Area area)`
`void` `removeAreas()`
`void` `resetMarker()`
`void` `rollback(java.util.Vector snapshot)` When balancing occurs, the flow layout() method restarts at the point specified by the current marker snapshot, which is retrieved and restored using this method.
`void` `setBodyIndent(int indent)`
`void` `setDistanceBetweenStarts(int distance)`
`void` `setIsInLabel()`
`void` `setIsInListBody()`
`void` `setIsInTableCell()`
`void` `setLabelSeparation(int separation)`
`void` `setLinkSet(LinkSet linkSet)`
`void` `setOrphans(int orph)`
`void` `setWidows(int wid)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### parent

    protected FObj parent

### children

    public java.util.Vector children

### START

    public static final int START

  value of marker before layout begins

### BREAK_AFTER

    public static final int BREAK_AFTER

  value of marker after break-after

### marker

    protected int marker

  where the layout was up to. for FObjs it is the child number for FOText it is the character number

### isInLabel

    protected boolean isInLabel

### isInListBody

    protected boolean isInListBody

### isInTableCell

    protected boolean isInTableCell

### bodyIndent

    protected int bodyIndent

### distanceBetweenStarts

    protected int distanceBetweenStarts

### labelSeparation

    protected int labelSeparation

### forcedStartOffset

    protected int forcedStartOffset

### forcedWidth

    protected int forcedWidth

### widows

    protected int widows

### orphans

    protected int orphans

### linkSet

    protected LinkSet linkSet

Constructor Detail

### FONode

    protected FONode(FObj parent)

Method Detail

### setIsInLabel

    public void setIsInLabel()

### setIsInListBody

    public void setIsInListBody()

### setIsInTableCell

    public void setIsInTableCell()

### setDistanceBetweenStarts

    public void setDistanceBetweenStarts(int distance)

### setLabelSeparation

    public void setLabelSeparation(int separation)

### setBodyIndent

    public void setBodyIndent(int indent)

### forceStartOffset

    public void forceStartOffset(int offset)

### forceWidth

    public void forceWidth(int width)

### resetMarker

    public void resetMarker()

### setWidows

    public void setWidows(int wid)

### setOrphans

    public void setOrphans(int orph)

### removeAreas

    public void removeAreas()

### addChild

    protected void addChild(FONode child)

### getParent

    public FObj getParent()

### setLinkSet

    public void setLinkSet(LinkSet linkSet)

### getLinkSet

    public LinkSet getLinkSet()

### layout

    public abstract Status layout(Area area)
                           throws FOPException

### getProperty

    public Property getProperty(java.lang.String name)

  lets outside sources access the property list first used by PageNumberCitation to find the "id" property returns null by default, overide this function when there is a property list
  Parameters:
    `name` - - the name of the desired property to obtain

### getMarkerSnapshot

    public java.util.Vector getMarkerSnapshot(java.util.Vector snapshot)

  At the start of a new span area layout may be partway through a nested FO, and balancing requires rollback to this known point. The snapshot records exactly where layout is at.
  Parameters:
    `snapshot` - a Vector of markers (Integer)

### rollback

    public void rollback(java.util.Vector snapshot)

  When balancing occurs, the flow layout() method restarts at the point specified by the current marker snapshot, which is retrieved and restored using this method.
  Parameters:
    `snapshot` - the Vector of saved markers (Integers)

Copyright © 1999-2001 Apache Software Foundation. All Rights Reserved.